`default_nettype none
`timescale 1ns / 10ps
// stb,cyc,cab,we 4  sel, 4, dat_i,adr 64 = 72
module wb_dualmastermux
  (
   input wire [1:0] sel_i,
   input wire nocsel_i,
    input wire [76:0] master0,
    input wire [76:0] master1,
    input wire [76:0] master2,
    input wire [76:0] master3,
    input wire [76:0] master4,
    output wire [76:0] nocmux_o,
    output wire [76:0] mux_o
   );

   reg [76:0] 	      nocmux;

   assign 	      nocmux_o = nocmux;
   
   always @(*) begin
      case(sel_i)
	2'd0:    nocmux = master1;
	2'd1:    nocmux = master2;
	2'd2:    nocmux = master3;
	default: nocmux = master4;
      endcase // case(sel_i)
   end

   assign mux_o = nocsel_i ? master0 : nocmux;
   

endmodule // wb_mastermux
