`default_nettype none
`timescale 1ns / 10ps
module wb_dualselgen(
    input wire [31:0] addr_i,
    output wire [3:0] selgen_o,
    output reg [1:0] selnum_o);


   parameter [31:0] S0_ADDR = 32'h00000000;
   parameter [31:0] S1_ADDR = 32'h00004000;
   parameter [31:0] S2_ADDR = 32'h00008000;
   parameter [31:0] S3_ADDR = 32'h0000c000;

   parameter [31:0] S0_MASK = 32'h0000c000;
   parameter [31:0] S1_MASK = 32'h0000c000;
   parameter [31:0] S2_MASK = 32'h0000c000;
   parameter [31:0] S3_MASK = 32'h0000c000;
   

   assign selgen_o = {((addr_i & S3_MASK) == S3_ADDR),
	       ((addr_i & S2_MASK) == S2_ADDR),
	       ((addr_i & S1_MASK) == S1_ADDR),
	       ((addr_i & S0_MASK) == S0_ADDR)};



   always @(*) begin
      if((addr_i & S0_MASK) == S0_ADDR) begin
	 selnum_o <= 2'd0;
      end else if((addr_i & S1_MASK) == S1_ADDR) begin
	 selnum_o <= 2'd1;
      end else if((addr_i & S2_MASK) == S2_ADDR) begin
	 selnum_o <= 2'd2;
      end else begin
	 selnum_o <= 2'd3;
      end
   end
   
endmodule // wb_dualselgen

