`timescale 1ns / 10ps
// 32 dat_o, 1 ack, 1 rty, 1 err = 35
module wb_dualslavemux
  (
    input wire [1:0] sel_i,
    input wire 	     nocsel_i,
    input wire [34:0] slave0,
    input wire [34:0] slave1,
    input wire [34:0] slave2,
    input wire [34:0] slave3,
    input wire [34:0] slave4,
    output wire [34:0] mux_o,
    output wire [34:0] nocmux_o
   );

   reg [34:0] 	      nocmux;

   assign 	      nocmux_o = nocmux;
   always @(*) begin
      case(sel_i)
	2'd0: nocmux = slave1;
	2'd1: nocmux = slave2;
	2'd2: nocmux = slave3;
	default: nocmux = slave4;
      endcase // case(sel_i)
   end

   assign mux_o = nocsel_i ? slave0 : nocmux;

endmodule // wb_slavemux
