`timescale 1ns / 10ps
module wb_dualslavesel
  (
   input wire clk_i,
   input wire rst_i,

   input wire cyc,
   input wire ack,
   
   input wire [31:0] addr_i,
   input wire [31:0] nocaddr_i,
   output reg [1:0] sel_o,
   output reg sel0_o,
   output reg sel1_o,
   output reg sel2_o,
   output reg sel3_o,
   output reg sel4_o,


   output wire nomatch_o
   );

   // XXX - parameterize this better!
   parameter  [4:0]  baseaddr = 5'h0;
   parameter [1:0]   s0_addr  = 2'h0;
   parameter [1:0]   s1_addr  = 2'h1;
   parameter [1:0]   s2_addr  = 2'h2;
   parameter [1:0]   s3_addr  = 2'h3;


   wire        baseaddr_match;
   
   assign      baseaddr_match = (addr_i[31:27] == baseaddr);
   

   always @(posedge clk_i) begin
      if(rst_i) begin
	 sel_o <= 2'd0;
	 sel1_o <= 0;
	 sel2_o <= 0;
	 sel3_o <= 0;
	 sel4_o <= 0;
      end else begin
	 if(!cyc) begin
	    sel1_o <= 0;
	    sel2_o <= 0;
	    sel3_o <= 0;
	    sel4_o <= 0;
	 end else begin
	    sel1_o <= baseaddr_match && (addr_i[26:25] == s0_addr);
	    sel2_o <= baseaddr_match && (addr_i[26:25] == s1_addr);
	    sel3_o <= baseaddr_match && (addr_i[26:25] == s2_addr);
	    sel4_o <= baseaddr_match && (addr_i[26:25] == s3_addr);
	 end
	 sel_o = addr_i[26:25];

	 // sel-signalerna kommer försent, de borde nog integreras i arbiter-modulen!
	 // De hör hursomhelst hemma där i vilket fall som helst...
	 if(nocaddr_i[31:27] != baseaddr) begin
	    sel0_o <= 1;
	 end else begin
	    sel0_o <= 0;
	 end

      end // else: !if(rst_i)
   end


endmodule // wb_slavesel
