`default_nettype none
`timescale 1ns / 10ps
module wb_monitor(
    input wire clk_i, rst_i,
    input wire ack_i,rty_i,err_i,
    input wire stb_i,cyc_i,
    input wire gnt_i);

   integer     timer;


   always @(posedge clk_i) begin
      if(rst_i) begin
	 timer = 0;
	 end else if(stb_i && cyc_i && gnt_i) begin
	 timer = timer + 1;
	 if(ack_i || rty_i || err_i) begin
	    timer = 0;
	 end

	 if(timer > 128) begin
	    $display("%m: No WB response for more than 128 clock cycles!");
	    $stop;
	 end
      end else begin
	 timer = 0;
      end
   end

endmodule
