`timescale 1ns / 10ps
// A simple 4-1 mux with four control signals to select the output
module muxbit(input wire clk,
	      input wire rst,
	      input wire a, b, c, d,

	      input wire Asel, Boverride,
	      input wire Csel, Doverride,
	      input wire muxsel,
	      output wire q);


   wire 	     result;
   wire 	     partial0, partial1;

   // baBA  (b, a, Boverride, Asel)
   // 0000    0
   // 0001    0
   // 0010    0
   // 0011    0
   // 0100    0
   // 0101    1
   // 0110    0
   // 0111    0
   // 1000    1
   // 1001    0
   // 1010    1
   // 1011    1
   // 1100    1
   // 1101    1
   // 1110    1
   // 1111    1
   

   defparam 	     lut0.INIT = 16'b1111110100100000;
   defparam 	     lut1.INIT = 16'b1111110100100000;
   
   (* RLOC = "X0Y0" *) LUT4 lut0(.I0(Asel),.I1(Boverride),.I2(a),.I3(b),.O(partial0));
   (* RLOC = "X0Y0" *) LUT4 lut1(.I0(Csel),.I1(Doverride),.I2(c),.I3(d),.O(partial1));
   (* RLOC = "X0Y0" *) MUXF5 mux(.I0(partial0),.I1(partial1),.S(muxsel),.O(result));
   (* RLOC = "X0Y0" *) FDR fd(.Q(q),.D(result),.R(rst),.C(clk));

endmodule // muxbit
