`timescale 1ns / 10ps
// Route lookup
module nextroute(
		 input wire clk,
		 input wire rst,

		 input wire ce,
		 input wire [4:0] destaddr,
		 
		 output wire sel);

   

   wire 	       lut1_out;
   wire 	       lut2_out;
   wire 	       mux_out;

   parameter [31:0]    ROUTE  = 32'h00000000;

   defparam 	       lut1.INIT = ROUTE[15:0];
   defparam 	       lut2.INIT = ROUTE[31:16];
   
   (* RLOC = "X0Y0" *) LUT4 lut1 (.I0(destaddr[0]),.I1(destaddr[1]),.I2(destaddr[2]),.I3(destaddr[3]),.O(lut1_out));
   (* RLOC = "X0Y0" *) LUT4 lut2 (.I0(destaddr[0]),.I1(destaddr[1]),.I2(destaddr[2]),.I3(destaddr[3]),.O(lut2_out));
   (* RLOC = "X0Y0" *) MUXF5 mux (.I0(lut1_out),.I1(lut2_out),.S(destaddr[4]),.O(mux_out));
   (* RLOC = "X0Y0" *) FDRE fd (.C(clk),.R(rst),.CE(ce),.D(mux_out),.Q(sel));

endmodule // nextroute

				
