`timescale 1ns / 10ps
`default_nettype none

  // Just here to allow a node to be synthesized
  // without worrying about IOBs interfering with the
  // timing margins
  
module node_wrap(input wire  clk, rst,
    input wire [48:0] scan_i,
    output wire [48:0] west_o,
    output wire [48:0] east_o,
    output wire [48:0] north_o,
    output wire [48:0] south_o,
    output wire [48:0] local_o);


   reg [48:0] 	       west_i;
   reg [48:0] 	       east_i;
   reg [48:0] 	       south_i;
   reg [48:0] 	       north_i;
   reg [48:0] 	       local_i;
   
   always @(posedge clk) begin
      west_i <= scan_i;
      east_i <= west_i;
      south_i <= east_i;
      north_i <= south_i;
      local_i <= north_i;
   end


   node n(
	  // Outputs
	  .west_o			(west_o[48:0]),
	  .east_o			(east_o[48:0]),
	  .north_o			(north_o[48:0]),
	  .south_o			(south_o[48:0]),
	  .local_o			(local_o[48:0]),
	  // Inputs
	  .clk				(clk),
	  .rst				(rst),
	  .west_i			(west_i[48:0]),
	  .east_i			(east_i[48:0]),
	  .north_i			(north_i[48:0]),
	  .south_i			(south_i[48:0]),
	  .local_i			(local_i[48:0]));
   

endmodule // node_wrap

		 
