`timescale 1ns / 10ps
`default_nettype none
// This Verilog file automatically generated from controller.asm
//
module serial_wb_program(clk_i, pm_addr_i, pm_insn_o);
   input         clk_i;
   input  [8:0]  pm_addr_i;
   output [15:0] pm_insn_o;

   wire          clk_i;
   wire [8:0]    pm_addr_i;
   reg  [15:0]   pm_insn_o;



   always @(posedge clk_i)
       case(pm_addr_i)
        9'h000: pm_insn_o <= 16'hffff; // 	nop
        9'h001: pm_insn_o <= 16'hffff; // 	nop
        9'h002: pm_insn_o <= 16'h4000; // 	set	#0x0,r0
        9'h003: pm_insn_o <= 16'h4100; // 	set	#0x0,r1
        9'h004: pm_insn_o <= 16'h40ff; // 	set	#0xff,r0
        9'h005: pm_insn_o <= 16'h41ff; // 	set	#0xff,r1
        9'h006: pm_insn_o <= 16'h0001; // 	add	r0,r1,r0
        9'h007: pm_insn_o <= 16'h8406; // 	jmpc	delayloop
        9'h008: pm_insn_o <= 16'hffff; // 	nop
        9'h009: pm_insn_o <= 16'h4040; // 	set	#0x40,r0
        9'h00a: pm_insn_o <= 16'h86c1; // 	jsr	putc
        9'h00b: pm_insn_o <= 16'h43e0; // 	set	#0xe0,r3	; Pointer to greeting string
        9'h00c: pm_insn_o <= 16'h9030; // 	out0	r3
        9'h00d: pm_insn_o <= 16'h6000; // 	ld	r0		; Load character
        9'h00e: pm_insn_o <= 16'h3000; // 	or	r0,r0,r0	; set flags
        9'h00f: pm_insn_o <= 16'h8215; // 	jmpz	endgreeting	; jump out of greetloop if NUL char
        9'h010: pm_insn_o <= 16'hffff; // 	nop
        9'h011: pm_insn_o <= 16'h86c1; // 	jsr	putc
        9'h012: pm_insn_o <= 16'h4001; // 	set	#0x01,r0
        9'h013: pm_insn_o <= 16'h0303; // 	add	r0,r3,r3	; charptr++
        9'h014: pm_insn_o <= 16'h800c; // 	jmp	greetloop
        9'h015: pm_insn_o <= 16'h400d; // 	set	#0x0d,r0	
        9'h016: pm_insn_o <= 16'h86c1; // 	jsr	putc
        9'h017: pm_insn_o <= 16'h400a; // 	set	#0x0a,r0
        9'h018: pm_insn_o <= 16'h86c1; // 	jsr	putc
        9'h019: pm_insn_o <= 16'h403e; // 	set	#0x3e,r0	; '>'
        9'h01a: pm_insn_o <= 16'h86c1; // 	jsr	putc		; print prompt
        9'h01b: pm_insn_o <= 16'h86cd; // 	jsr	getc		; get command character
        9'h01c: pm_insn_o <= 16'h416f; // 	set	#0x6f,r1	; 'o' (out)
        9'h01d: pm_insn_o <= 16'h1101; // 	xor	r0,r1,r1
        9'h01e: pm_insn_o <= 16'h8237; // 	jmpz	handle_output	; Check if we have an o(ut) command
        9'h01f: pm_insn_o <= 16'hffff; // 	nop
        9'h020: pm_insn_o <= 16'h4169; // 	set	#0x69,r1	; 'i' (in)
        9'h021: pm_insn_o <= 16'h1101; // 	xor	r0,r1,r1
        9'h022: pm_insn_o <= 16'h822f; // 	jmpz	handle_input	; Check if we have an i(n) command
        9'h023: pm_insn_o <= 16'hffff; // 	nop
        9'h024: pm_insn_o <= 16'h4164; // 	set	#0x64,r1	; 'd' (display)
        9'h025: pm_insn_o <= 16'h1101; // 	xor	r0,r1,r1
        9'h026: pm_insn_o <= 16'h824c; // 	jmpz	handle_display	; Check if we have an i(n) command
        9'h027: pm_insn_o <= 16'hffff; // 	nop
        9'h028: pm_insn_o <= 16'h416d; // 	set	#0x6d,r1	; 'd' (modify)
        9'h029: pm_insn_o <= 16'h1101; // 	xor	r0,r1,r1
        9'h02a: pm_insn_o <= 16'h826d; // 	jmpz	handle_modify	; Check if we have an i(n) command
        9'h02b: pm_insn_o <= 16'hffff; // 	nop
        9'h02c: pm_insn_o <= 16'h4007; // 	set	#0x7,r0		; ctrl g
        9'h02d: pm_insn_o <= 16'h86c1; // 	jsr	putc
        9'h02e: pm_insn_o <= 16'h8015; // 	jmp	menuloop
        9'h02f: pm_insn_o <= 16'h400d; // 	set	#0x0d,r0
        9'h030: pm_insn_o <= 16'h86c1; // 	jsr	putc
        9'h031: pm_insn_o <= 16'h400a; // 	set	#0x0a,r0
        9'h032: pm_insn_o <= 16'h86c1; // 	jsr	putc
        9'h033: pm_insn_o <= 16'h4004; // 	set	#0x4,r0
        9'h034: pm_insn_o <= 16'h86fe; // 	jsr	getport
        9'h035: pm_insn_o <= 16'h8713; // 	jsr	printval
        9'h036: pm_insn_o <= 16'h8015; // 	jmp	menuloop
        9'h037: pm_insn_o <= 16'h4020; // 	set	#0x20,r0	; ' '
        9'h038: pm_insn_o <= 16'h86c1; // 	jsr	putc
        9'h039: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h03a: pm_insn_o <= 16'h7730; // 	swap	r3,r7
        9'h03b: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h03c: pm_insn_o <= 16'h3737; // 	or	r3,r7,r7
        9'h03d: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h03e: pm_insn_o <= 16'h7630; // 	swap	r3,r6
        9'h03f: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h040: pm_insn_o <= 16'h3636; // 	or	r3,r6,r6
        9'h041: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h042: pm_insn_o <= 16'h7530; // 	swap	r3,r5
        9'h043: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h044: pm_insn_o <= 16'h3535; // 	or	r3,r5,r5
        9'h045: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h046: pm_insn_o <= 16'h7430; // 	swap	r3,r4
        9'h047: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h048: pm_insn_o <= 16'h3434; // 	or	r3,r4,r4
        9'h049: pm_insn_o <= 16'h4004; // 	set	#0x4,r0
        9'h04a: pm_insn_o <= 16'h86f1; // 	jsr	setport
        9'h04b: pm_insn_o <= 16'h8015; // 	jmp	menuloop
        9'h04c: pm_insn_o <= 16'h4020; // 	set	#0x20,r0	; ' '
        9'h04d: pm_insn_o <= 16'h86c1; // 	jsr	putc
        9'h04e: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h04f: pm_insn_o <= 16'h7730; // 	swap	r3,r7
        9'h050: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h051: pm_insn_o <= 16'h3737; // 	or	r3,r7,r7
        9'h052: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h053: pm_insn_o <= 16'h7630; // 	swap	r3,r6
        9'h054: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h055: pm_insn_o <= 16'h3636; // 	or	r3,r6,r6
        9'h056: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h057: pm_insn_o <= 16'h7530; // 	swap	r3,r5
        9'h058: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h059: pm_insn_o <= 16'h3535; // 	or	r3,r5,r5
        9'h05a: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h05b: pm_insn_o <= 16'h7430; // 	swap	r3,r4
        9'h05c: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h05d: pm_insn_o <= 16'h3434; // 	or	r3,r4,r4
        9'h05e: pm_insn_o <= 16'h400d; // 	set	#0x0d,r0
        9'h05f: pm_insn_o <= 16'h86c1; // 	jsr	putc
        9'h060: pm_insn_o <= 16'h400a; // 	set	#0x0a,r0
        9'h061: pm_insn_o <= 16'h86c1; // 	jsr	putc
        9'h062: pm_insn_o <= 16'h4010; // 	set	#0x10,r0
        9'h063: pm_insn_o <= 16'h86f1; // 	jsr	setport
        9'h064: pm_insn_o <= 16'h4018; // 	set	#0x18,r0
        9'h065: pm_insn_o <= 16'h45f1; // 	set	#0xf1,r5
        9'h066: pm_insn_o <= 16'h9000; // 	out0	r0
        9'h067: pm_insn_o <= 16'h9150; // 	out1	r5
        9'h068: pm_insn_o <= 16'h869b; // 	jsr	waitwishbone
        9'h069: pm_insn_o <= 16'h4014; // 	set	#0x14,r0
        9'h06a: pm_insn_o <= 16'h86fe; // 	jsr	getport
        9'h06b: pm_insn_o <= 16'h8713; // 	jsr	printval
        9'h06c: pm_insn_o <= 16'h8015; // 	jmp	menuloop
        9'h06d: pm_insn_o <= 16'h4020; // 	set	#0x20,r0	; ' '
        9'h06e: pm_insn_o <= 16'h86c1; // 	jsr	putc
        9'h06f: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h070: pm_insn_o <= 16'h7730; // 	swap	r3,r7
        9'h071: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h072: pm_insn_o <= 16'h3737; // 	or	r3,r7,r7
        9'h073: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h074: pm_insn_o <= 16'h7630; // 	swap	r3,r6
        9'h075: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h076: pm_insn_o <= 16'h3636; // 	or	r3,r6,r6
        9'h077: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h078: pm_insn_o <= 16'h7530; // 	swap	r3,r5
        9'h079: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h07a: pm_insn_o <= 16'h3535; // 	or	r3,r5,r5
        9'h07b: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h07c: pm_insn_o <= 16'h7430; // 	swap	r3,r4
        9'h07d: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h07e: pm_insn_o <= 16'h3434; // 	or	r3,r4,r4
        9'h07f: pm_insn_o <= 16'h4020; // 	set	#0x20,r0
        9'h080: pm_insn_o <= 16'h86c1; // 	jsr	putc
        9'h081: pm_insn_o <= 16'h4010; // 	set	#0x10,r0
        9'h082: pm_insn_o <= 16'h86f1; // 	jsr	setport
        9'h083: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h084: pm_insn_o <= 16'h7730; // 	swap	r3,r7
        9'h085: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h086: pm_insn_o <= 16'h3737; // 	or	r3,r7,r7
        9'h087: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h088: pm_insn_o <= 16'h7630; // 	swap	r3,r6
        9'h089: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h08a: pm_insn_o <= 16'h3636; // 	or	r3,r6,r6
        9'h08b: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h08c: pm_insn_o <= 16'h7530; // 	swap	r3,r5
        9'h08d: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h08e: pm_insn_o <= 16'h3535; // 	or	r3,r5,r5
        9'h08f: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h090: pm_insn_o <= 16'h7430; // 	swap	r3,r4
        9'h091: pm_insn_o <= 16'h8728; // 	jsr	getnibble
        9'h092: pm_insn_o <= 16'h3434; // 	or	r3,r4,r4
        9'h093: pm_insn_o <= 16'h4014; // 	set	#0x14,r0
        9'h094: pm_insn_o <= 16'h86f1; // 	jsr	setport	
        9'h095: pm_insn_o <= 16'h4018; // 	set	#0x18,r0
        9'h096: pm_insn_o <= 16'h45f9; // 	set	#0xf9,r5
        9'h097: pm_insn_o <= 16'h9000; // 	out0	r0
        9'h098: pm_insn_o <= 16'h9150; // 	out1	r5
        9'h099: pm_insn_o <= 16'h869b; // 	jsr	waitwishbone
        9'h09a: pm_insn_o <= 16'h8015; // 	jmp	menuloop
        9'h09b: pm_insn_o <= 16'h4401; // 	set	#0x1,r4		; retry counter
        9'h09c: pm_insn_o <= 16'h4001; // 	set	#0x1,r0
        9'h09d: pm_insn_o <= 16'h4101; // 	set	#0x1,r1		; loop counter
        9'h09e: pm_insn_o <= 16'h0101; // 	add	r0,r1,r1	; Inc loop counter
        9'h09f: pm_insn_o <= 16'h82bb; // 	jmpz	waitwb_timeout	; We got a timeout here
        9'h0a0: pm_insn_o <= 16'hffff; // 	nop
        9'h0a1: pm_insn_o <= 16'h5200; // 	in2	r2		; get status
        9'h0a2: pm_insn_o <= 16'h2302; // 	and	r0,r2,r3
        9'h0a3: pm_insn_o <= 16'h82a6; // 	jmpz	waitwb_finished	; Transaction complete
        9'h0a4: pm_insn_o <= 16'hffff; // 	nop
        9'h0a5: pm_insn_o <= 16'h809e; // 	jmp	waitwb_loop
        9'h0a6: pm_insn_o <= 16'h4002; // 	set	#0x2,r0
        9'h0a7: pm_insn_o <= 16'h2302; // 	and	r0,r2,r3	; Check for WB error in the WBmaster
        9'h0a8: pm_insn_o <= 16'h82ac; // 	jmpz	waitwb_noerror	; control register
        9'h0a9: pm_insn_o <= 16'hffff; // 	nop
        9'h0aa: pm_insn_o <= 16'h43a0; // 	set	#0xa0,r3	; Print WB Error
        9'h0ab: pm_insn_o <= 16'h800c; // 	jmp	greetloop
        9'h0ac: pm_insn_o <= 16'h4004; // 	set	#0x4,r0
        9'h0ad: pm_insn_o <= 16'h2302; // 	and	r0,r2,r3	; Check for WB retry status in the
        9'h0ae: pm_insn_o <= 16'h82ba; // 	jmpz	waitwb_noretry	; WBmaster control register
        9'h0af: pm_insn_o <= 16'hffff; // 	nop
        9'h0b0: pm_insn_o <= 16'h4001; // 	set	#0x1,r0
        9'h0b1: pm_insn_o <= 16'h0404; // 	add	r0,r4,r4	; Increase retry counter
        9'h0b2: pm_insn_o <= 16'h82b8; // 	jmpz	waitwb_toomany_retries; Too many retries...
        9'h0b3: pm_insn_o <= 16'hffff; // 	nop
        9'h0b4: pm_insn_o <= 16'h4018; // 	set	#0x18,r0
        9'h0b5: pm_insn_o <= 16'h9000; // 	out0	r0
        9'h0b6: pm_insn_o <= 16'h9150; // 	out1	r5		; Restart the transaction
        9'h0b7: pm_insn_o <= 16'h809c; // 	jmp	waitwb_retry_transaction
        9'h0b8: pm_insn_o <= 16'h4380; // 	set	#0x80,r3	; Print WB Retry
        9'h0b9: pm_insn_o <= 16'h800c; // 	jmp	greetloop
        9'h0ba: pm_insn_o <= 16'h8800; // 	rts			; No error, return to caller
        9'h0bb: pm_insn_o <= 16'h4018; // 	set	#0x18,r0	; transaction
        9'h0bc: pm_insn_o <= 16'h4100; // 	set	#0x0,r1
        9'h0bd: pm_insn_o <= 16'h9000; // 	out0	r0
        9'h0be: pm_insn_o <= 16'h9110; // 	out1	r1		; Reset the WB transaction here.
        9'h0bf: pm_insn_o <= 16'h43c0; // 	set	#0xc0,r3
        9'h0c0: pm_insn_o <= 16'h800c; // 	jmp	greetloop
        9'h0c1: pm_insn_o <= 16'h4101; // 	set	#0x1,r1
        9'h0c2: pm_insn_o <= 16'h9010; // 	out0	r1
        9'h0c3: pm_insn_o <= 16'h4202; // 	set	#0x2,r2		; UART_TX_IDLE
        9'h0c4: pm_insn_o <= 16'hffff; // 	nop
        9'h0c5: pm_insn_o <= 16'h5100; // 	in2	r1		; get status flags from UART
        9'h0c6: pm_insn_o <= 16'h2112; // 	and	r1,r2,r1	; zero flag set if no TX slot available
        9'h0c7: pm_insn_o <= 16'h82c5; // 	jmpz	putc_waitidle
        9'h0c8: pm_insn_o <= 16'hffff; // 	nop
        9'h0c9: pm_insn_o <= 16'h4100; // 	set	#0x0,r1		; Output register of UART
        9'h0ca: pm_insn_o <= 16'h9010; // 	out0	r1		; Address for TX transmit reg
        9'h0cb: pm_insn_o <= 16'h9100; // 	out1	r0		; Transmit character
        9'h0cc: pm_insn_o <= 16'h8800; // 	rts
        9'h0cd: pm_insn_o <= 16'h4101; // 	set	#0x1,r1
        9'h0ce: pm_insn_o <= 16'h9010; // 	out0	r1
        9'h0cf: pm_insn_o <= 16'h4201; // 	set	#0x1,r2		; UART_RX_IDLE
        9'h0d0: pm_insn_o <= 16'hffff; // 	nop
        9'h0d1: pm_insn_o <= 16'h5100; // 	in2	r1
        9'h0d2: pm_insn_o <= 16'h2112; // 	and	r1,r2,r1
        9'h0d3: pm_insn_o <= 16'h82d1; // 	jmpz	getc_waitchar
        9'h0d4: pm_insn_o <= 16'hffff; // 	nop
        9'h0d5: pm_insn_o <= 16'h4100; // 	set	#0x0,r1		; Address of RX recv reg
        9'h0d6: pm_insn_o <= 16'h9010; // 	out0	r1
        9'h0d7: pm_insn_o <= 16'hffff; // 	nop
        9'h0d8: pm_insn_o <= 16'hffff; // 	nop
        9'h0d9: pm_insn_o <= 16'h5000; // 	in2	r0		; Get character
        9'h0da: pm_insn_o <= 16'h4103; // 	set	#0x3,r1		; ctrl c
        9'h0db: pm_insn_o <= 16'h1101; // 	xor	r0,r1,r1
        9'h0dc: pm_insn_o <= 16'h8200; // 	jmpz	restart		; Restart if ctrl c was pressed
        9'h0dd: pm_insn_o <= 16'hffff; // 	nop
        9'h0de: pm_insn_o <= 16'h80c1; // 	jmp	putc		; Echo character
        9'h0df: pm_insn_o <= 16'h4101; // 	set	#0x1,r1
        9'h0e0: pm_insn_o <= 16'h9010; // 	out0	r1
        9'h0e1: pm_insn_o <= 16'h4201; // 	set	#0x1,r2		; UART_RX_IDLE
        9'h0e2: pm_insn_o <= 16'hffff; // 	nop
        9'h0e3: pm_insn_o <= 16'h5100; // 	in2	r1
        9'h0e4: pm_insn_o <= 16'h2112; // 	and	r1,r2,r1
        9'h0e5: pm_insn_o <= 16'h82e3; // 	jmpz	getc_quiet_waitchar
        9'h0e6: pm_insn_o <= 16'hffff; // 	nop
        9'h0e7: pm_insn_o <= 16'h4100; // 	set	#0x0,r1		; Address of RX recv reg
        9'h0e8: pm_insn_o <= 16'h9010; // 	out0	r1
        9'h0e9: pm_insn_o <= 16'hffff; // 	nop
        9'h0ea: pm_insn_o <= 16'hffff; // 	nop
        9'h0eb: pm_insn_o <= 16'h5000; // 	in2	r0		; Get character
        9'h0ec: pm_insn_o <= 16'h4103; // 	set	#0x3,r1		; ctrl c
        9'h0ed: pm_insn_o <= 16'h1101; // 	xor	r0,r1,r1
        9'h0ee: pm_insn_o <= 16'h8200; // 	jmpz	restart		; Restart if ctrl c was pressed
        9'h0ef: pm_insn_o <= 16'hffff; // 	nop
        9'h0f0: pm_insn_o <= 16'h8800; // 	rts
        9'h0f1: pm_insn_o <= 16'h4101; // 	set	#0x1,r1		; inc factor
        9'h0f2: pm_insn_o <= 16'h9000; // 	out0	r0
        9'h0f3: pm_insn_o <= 16'h9140; // 	out1	r4
        9'h0f4: pm_insn_o <= 16'h0001; // 	add	r0,r1,r0
        9'h0f5: pm_insn_o <= 16'h9000; // 	out0	r0
        9'h0f6: pm_insn_o <= 16'h9150; // 	out1	r5
        9'h0f7: pm_insn_o <= 16'h0001; // 	add	r0,r1,r0
        9'h0f8: pm_insn_o <= 16'h9000; // 	out0	r0
        9'h0f9: pm_insn_o <= 16'h9160; // 	out1	r6
        9'h0fa: pm_insn_o <= 16'h0001; // 	add	r0,r1,r0
        9'h0fb: pm_insn_o <= 16'h9000; // 	out0	r0
        9'h0fc: pm_insn_o <= 16'h9170; // 	out1	r7
        9'h0fd: pm_insn_o <= 16'h8800; // 	rts
        9'h0fe: pm_insn_o <= 16'h4101; // 	set	#0x01,r1	; increment constant
        9'h0ff: pm_insn_o <= 16'h9000; // 	out0	r0
        9'h100: pm_insn_o <= 16'hffff; // 	nop
        9'h101: pm_insn_o <= 16'hffff; // 	nop
        9'h102: pm_insn_o <= 16'h5700; // 	in2	r7
        9'h103: pm_insn_o <= 16'h0001; // 	add	r0,r1,r0
        9'h104: pm_insn_o <= 16'h9000; // 	out0	r0
        9'h105: pm_insn_o <= 16'hffff; // 	nop
        9'h106: pm_insn_o <= 16'hffff; // 	nop
        9'h107: pm_insn_o <= 16'h5600; // 	in2	r6
        9'h108: pm_insn_o <= 16'h0001; // 	add	r0,r1,r0
        9'h109: pm_insn_o <= 16'h9000; // 	out0	r0
        9'h10a: pm_insn_o <= 16'hffff; // 	nop
        9'h10b: pm_insn_o <= 16'hffff; // 	nop
        9'h10c: pm_insn_o <= 16'h5500; // 	in2	r5
        9'h10d: pm_insn_o <= 16'h0001; // 	add	r0,r1,r0
        9'h10e: pm_insn_o <= 16'h9000; // 	out0	r0
        9'h10f: pm_insn_o <= 16'hffff; // 	nop
        9'h110: pm_insn_o <= 16'hffff; // 	nop
        9'h111: pm_insn_o <= 16'h5400; // 	in2	r4
        9'h112: pm_insn_o <= 16'h8800; // 	rts
        9'h113: pm_insn_o <= 16'h3044; // 	or	r4,r4,r0	; move r4,r0
        9'h114: pm_insn_o <= 16'h8748; // 	jsr	convnibble
        9'h115: pm_insn_o <= 16'h86c1; // 	jsr	putc
        9'h116: pm_insn_o <= 16'h3033; // 	or	r3,r3,r0
        9'h117: pm_insn_o <= 16'h86c1; // 	jsr	putc
        9'h118: pm_insn_o <= 16'h3055; // 	or	r5,r5,r0	; move r5,r0
        9'h119: pm_insn_o <= 16'h8748; // 	jsr	convnibble
        9'h11a: pm_insn_o <= 16'h86c1; // 	jsr	putc
        9'h11b: pm_insn_o <= 16'h3033; // 	or	r3,r3,r0
        9'h11c: pm_insn_o <= 16'h86c1; // 	jsr	putc
        9'h11d: pm_insn_o <= 16'h3066; // 	or	r6,r6,r0	; move r6,r0
        9'h11e: pm_insn_o <= 16'h8748; // 	jsr	convnibble
        9'h11f: pm_insn_o <= 16'h86c1; // 	jsr	putc
        9'h120: pm_insn_o <= 16'h3033; // 	or	r3,r3,r0
        9'h121: pm_insn_o <= 16'h86c1; // 	jsr	putc
        9'h122: pm_insn_o <= 16'h3077; // 	or	r7,r7,r0	; move r7,r0
        9'h123: pm_insn_o <= 16'h8748; // 	jsr	convnibble
        9'h124: pm_insn_o <= 16'h86c1; // 	jsr	putc
        9'h125: pm_insn_o <= 16'h3033; // 	or	r3,r3,r0
        9'h126: pm_insn_o <= 16'h86c1; // 	jsr	putc
        9'h127: pm_insn_o <= 16'h8800; // 	rts
        9'h128: pm_insn_o <= 16'h86df; // 	jsr	getc_quiet
        9'h129: pm_insn_o <= 16'h41d0; // 	set	#0xd0,r1	; 0x100 - 0x30
        9'h12a: pm_insn_o <= 16'h0101; // 	add	r0,r1,r1
        9'h12b: pm_insn_o <= 16'h8530; // 	jmpc	convascii_ge0	; jump if greater or equal to '0'
        9'h12c: pm_insn_o <= 16'hffff; // 	nop
        9'h12d: pm_insn_o <= 16'h4007; // 	set	#0x7,r0		; ctrl g
        9'h12e: pm_insn_o <= 16'h86c1; // 	jsr	putc
        9'h12f: pm_insn_o <= 16'h8128; // 	jmp	getnibble	; restart nibbleloop
        9'h130: pm_insn_o <= 16'h41c6; // 	set	#0xc6,r1	; 0x100 - 0x39
        9'h131: pm_insn_o <= 16'h0101; // 	add	r0,r1,r1
        9'h132: pm_insn_o <= 16'h8537; // 	jmpc	convascii_gt9
        9'h133: pm_insn_o <= 16'hffff; // 	nop
        9'h134: pm_insn_o <= 16'h41d0; // 	set	#0xd0,r1		; -0x30
        9'h135: pm_insn_o <= 16'h0301; // 	add	r0,r1,r3	; result in r3
        9'h136: pm_insn_o <= 16'h80c1; // 	jmp	putc		; jump to putc to end it all
        9'h137: pm_insn_o <= 16'h419f; // 	set	#0x9f,r1	; 0x100 - 0x61 ('a')
        9'h138: pm_insn_o <= 16'h0101; // 	add	r0,r1,r1
        9'h139: pm_insn_o <= 16'h853e; // 	jmpc	convascii_gea	; Value is larger than or equal to 'a'
        9'h13a: pm_insn_o <= 16'hffff; // 	nop
        9'h13b: pm_insn_o <= 16'h4007; // 	set	#0x7,r0		; ctrl g
        9'h13c: pm_insn_o <= 16'h86c1; // 	jsr	putc
        9'h13d: pm_insn_o <= 16'h8128; // 	jmp	getnibble	; restart nibbleloop
        9'h13e: pm_insn_o <= 16'h4199; // 	set	#0x99,r1; 0x100 - 0x66 - 1 (0x66 = 'f')
        9'h13f: pm_insn_o <= 16'h0101; // 	add	r0,r1,r1
        9'h140: pm_insn_o <= 16'h8545; // 	jmpc	invalidchar
        9'h141: pm_insn_o <= 16'hffff; // 	nop
        9'h142: pm_insn_o <= 16'h41a9; // 	set	#0xa9,r1	; -0x61+0xa
        9'h143: pm_insn_o <= 16'h0301; // 	add	r0,r1,r3	; result in r3
        9'h144: pm_insn_o <= 16'h80c1; // 	jmp	putc
        9'h145: pm_insn_o <= 16'h4007; //  	set	#0x7,r0
        9'h146: pm_insn_o <= 16'h86c1; //  	jsr	putc
        9'h147: pm_insn_o <= 16'h8128; // 	jmp	getnibble
        9'h148: pm_insn_o <= 16'h420f; // 	set	#0xf,r2 	; Mask out LSB nibble
        9'h149: pm_insn_o <= 16'h2202; // 	and	r0,r2,r2
        9'h14a: pm_insn_o <= 16'h43f6; // 	set	#0xf6,r3
        9'h14b: pm_insn_o <= 16'h0323; // 	add	r2,r3,r3
        9'h14c: pm_insn_o <= 16'h8551; // 	jmpc	convnibble_lsb_gtten ; Jump if r2 greater than 9
        9'h14d: pm_insn_o <= 16'hffff; // 	nop
        9'h14e: pm_insn_o <= 16'h4330; // 	set	#0x30,r3	; '0'
        9'h14f: pm_insn_o <= 16'h0123; // 	add	r2,r3,r1	; convert first nibble into '0'..'9'
        9'h150: pm_insn_o <= 16'h8153; // 	jmp	convnibble_msb
        9'h151: pm_insn_o <= 16'h4357; // 	set	#0x57,r3	; 'a'
        9'h152: pm_insn_o <= 16'h0123; // 	add	r2,r3,r1
        9'h153: pm_insn_o <= 16'h420f; // 	set	#0xf,r2		; mask out MSB nibble
        9'h154: pm_insn_o <= 16'h7000; // 	swap	r0,r0
        9'h155: pm_insn_o <= 16'h2202; // 	and	r0,r2,r2
        9'h156: pm_insn_o <= 16'h43f6; // 	set	#0xf6,r3
        9'h157: pm_insn_o <= 16'h0323; // 	add	r2,r3,r3
        9'h158: pm_insn_o <= 16'h855d; // 	jmpc	convnibble_msb_gtten
        9'h159: pm_insn_o <= 16'hffff; // 	nop
        9'h15a: pm_insn_o <= 16'h4330; // 	set	#0x30,r3	; '0'
        9'h15b: pm_insn_o <= 16'h0023; // 	add	r2,r3,r0
        9'h15c: pm_insn_o <= 16'h815f; // 	jmp	convnibble_msb_done
        9'h15d: pm_insn_o <= 16'h4357; // 	set	#0x57,r3	; 'a'
        9'h15e: pm_insn_o <= 16'h0023; // 	add	r2,r3,r0
        9'h15f: pm_insn_o <= 16'h3311; // 	or	r1,r1,r3	; move r1 to r0 (ugly kludge, rewrite algorithm)
        9'h160: pm_insn_o <= 16'h8800; // 	rts
        9'h161: pm_insn_o <= 16'h0000;
        9'h162: pm_insn_o <= 16'h0000;
        9'h163: pm_insn_o <= 16'h0000;
        9'h164: pm_insn_o <= 16'h0000;
        9'h165: pm_insn_o <= 16'h0000;
        9'h166: pm_insn_o <= 16'h0000;
        9'h167: pm_insn_o <= 16'h0000;
        9'h168: pm_insn_o <= 16'h0000;
        9'h169: pm_insn_o <= 16'h0000;
        9'h16a: pm_insn_o <= 16'h0000;
        9'h16b: pm_insn_o <= 16'h0000;
        9'h16c: pm_insn_o <= 16'h0000;
        9'h16d: pm_insn_o <= 16'h0000;
        9'h16e: pm_insn_o <= 16'h0000;
        9'h16f: pm_insn_o <= 16'h0000;
        9'h170: pm_insn_o <= 16'h0000;
        9'h171: pm_insn_o <= 16'h0000;
        9'h172: pm_insn_o <= 16'h0000;
        9'h173: pm_insn_o <= 16'h0000;
        9'h174: pm_insn_o <= 16'h0000;
        9'h175: pm_insn_o <= 16'h0000;
        9'h176: pm_insn_o <= 16'h0000;
        9'h177: pm_insn_o <= 16'h0000;
        9'h178: pm_insn_o <= 16'h0000;
        9'h179: pm_insn_o <= 16'h0000;
        9'h17a: pm_insn_o <= 16'h0000;
        9'h17b: pm_insn_o <= 16'h0000;
        9'h17c: pm_insn_o <= 16'h0000;
        9'h17d: pm_insn_o <= 16'h0000;
        9'h17e: pm_insn_o <= 16'h0000;
        9'h17f: pm_insn_o <= 16'h0000;
        9'h180: pm_insn_o <= 16'h0000;
        9'h181: pm_insn_o <= 16'h0000;
        9'h182: pm_insn_o <= 16'h0000;
        9'h183: pm_insn_o <= 16'h0000;
        9'h184: pm_insn_o <= 16'h0000;
        9'h185: pm_insn_o <= 16'h0000;
        9'h186: pm_insn_o <= 16'h0000;
        9'h187: pm_insn_o <= 16'h0000;
        9'h188: pm_insn_o <= 16'h0000;
        9'h189: pm_insn_o <= 16'h0000;
        9'h18a: pm_insn_o <= 16'h0000;
        9'h18b: pm_insn_o <= 16'h0000;
        9'h18c: pm_insn_o <= 16'h0000;
        9'h18d: pm_insn_o <= 16'h0000;
        9'h18e: pm_insn_o <= 16'h0000;
        9'h18f: pm_insn_o <= 16'h0000;
        9'h190: pm_insn_o <= 16'h0000;
        9'h191: pm_insn_o <= 16'h0000;
        9'h192: pm_insn_o <= 16'h0000;
        9'h193: pm_insn_o <= 16'h0000;
        9'h194: pm_insn_o <= 16'h0000;
        9'h195: pm_insn_o <= 16'h0000;
        9'h196: pm_insn_o <= 16'h0000;
        9'h197: pm_insn_o <= 16'h0000;
        9'h198: pm_insn_o <= 16'h0000;
        9'h199: pm_insn_o <= 16'h0000;
        9'h19a: pm_insn_o <= 16'h0000;
        9'h19b: pm_insn_o <= 16'h0000;
        9'h19c: pm_insn_o <= 16'h0000;
        9'h19d: pm_insn_o <= 16'h0000;
        9'h19e: pm_insn_o <= 16'h0000;
        9'h19f: pm_insn_o <= 16'h0000;
        9'h1a0: pm_insn_o <= 16'h0000;
        9'h1a1: pm_insn_o <= 16'h0000;
        9'h1a2: pm_insn_o <= 16'h0000;
        9'h1a3: pm_insn_o <= 16'h0000;
        9'h1a4: pm_insn_o <= 16'h0000;
        9'h1a5: pm_insn_o <= 16'h0000;
        9'h1a6: pm_insn_o <= 16'h0000;
        9'h1a7: pm_insn_o <= 16'h0000;
        9'h1a8: pm_insn_o <= 16'h0000;
        9'h1a9: pm_insn_o <= 16'h0000;
        9'h1aa: pm_insn_o <= 16'h0000;
        9'h1ab: pm_insn_o <= 16'h0000;
        9'h1ac: pm_insn_o <= 16'h0000;
        9'h1ad: pm_insn_o <= 16'h0000;
        9'h1ae: pm_insn_o <= 16'h0000;
        9'h1af: pm_insn_o <= 16'h0000;
        9'h1b0: pm_insn_o <= 16'h0000;
        9'h1b1: pm_insn_o <= 16'h0000;
        9'h1b2: pm_insn_o <= 16'h0000;
        9'h1b3: pm_insn_o <= 16'h0000;
        9'h1b4: pm_insn_o <= 16'h0000;
        9'h1b5: pm_insn_o <= 16'h0000;
        9'h1b6: pm_insn_o <= 16'h0000;
        9'h1b7: pm_insn_o <= 16'h0000;
        9'h1b8: pm_insn_o <= 16'h0000;
        9'h1b9: pm_insn_o <= 16'h0000;
        9'h1ba: pm_insn_o <= 16'h0000;
        9'h1bb: pm_insn_o <= 16'h0000;
        9'h1bc: pm_insn_o <= 16'h0000;
        9'h1bd: pm_insn_o <= 16'h0000;
        9'h1be: pm_insn_o <= 16'h0000;
        9'h1bf: pm_insn_o <= 16'h0000;
        9'h1c0: pm_insn_o <= 16'h5742; // 	dw	0x5742		; WB
        9'h1c1: pm_insn_o <= 16'h2052; // 	dw	0x2052		;  R
        9'h1c2: pm_insn_o <= 16'h6574; // 	dw	0x6574		; et
        9'h1c3: pm_insn_o <= 16'h7279; // 	dw	0x7279		; ry
        9'h1c4: pm_insn_o <= 16'h0000; // 	dw	0x0000		; \0\0
        9'h1c5: pm_insn_o <= 16'h0000;
        9'h1c6: pm_insn_o <= 16'h0000;
        9'h1c7: pm_insn_o <= 16'h0000;
        9'h1c8: pm_insn_o <= 16'h0000;
        9'h1c9: pm_insn_o <= 16'h0000;
        9'h1ca: pm_insn_o <= 16'h0000;
        9'h1cb: pm_insn_o <= 16'h0000;
        9'h1cc: pm_insn_o <= 16'h0000;
        9'h1cd: pm_insn_o <= 16'h0000;
        9'h1ce: pm_insn_o <= 16'h0000;
        9'h1cf: pm_insn_o <= 16'h0000;
        9'h1d0: pm_insn_o <= 16'h5742; // 	dw	0x5742		; WB
        9'h1d1: pm_insn_o <= 16'h2045; // 	dw	0x2045		;  E
        9'h1d2: pm_insn_o <= 16'h7272; // 	dw	0x7272		; rr
        9'h1d3: pm_insn_o <= 16'h6572; // 	dw	0x6572		; or
        9'h1d4: pm_insn_o <= 16'h0000; // 	dw	0x0000		; \0\0
        9'h1d5: pm_insn_o <= 16'h0000;
        9'h1d6: pm_insn_o <= 16'h0000;
        9'h1d7: pm_insn_o <= 16'h0000;
        9'h1d8: pm_insn_o <= 16'h0000;
        9'h1d9: pm_insn_o <= 16'h0000;
        9'h1da: pm_insn_o <= 16'h0000;
        9'h1db: pm_insn_o <= 16'h0000;
        9'h1dc: pm_insn_o <= 16'h0000;
        9'h1dd: pm_insn_o <= 16'h0000;
        9'h1de: pm_insn_o <= 16'h0000;
        9'h1df: pm_insn_o <= 16'h0000;
        9'h1e0: pm_insn_o <= 16'h5742; // 	dw	0x5742		; WB
        9'h1e1: pm_insn_o <= 16'h2054; // 	dw	0x2054		;  T
        9'h1e2: pm_insn_o <= 16'h696d; // 	dw	0x696d		; im
        9'h1e3: pm_insn_o <= 16'h656f; // 	dw	0x656f		; eo
        9'h1e4: pm_insn_o <= 16'h7574; // 	dw	0x7574		; ut
        9'h1e5: pm_insn_o <= 16'h0000; // 	dw	0x0000		; \0\0
        9'h1e6: pm_insn_o <= 16'h0000;
        9'h1e7: pm_insn_o <= 16'h0000;
        9'h1e8: pm_insn_o <= 16'h0000;
        9'h1e9: pm_insn_o <= 16'h0000;
        9'h1ea: pm_insn_o <= 16'h0000;
        9'h1eb: pm_insn_o <= 16'h0000;
        9'h1ec: pm_insn_o <= 16'h0000;
        9'h1ed: pm_insn_o <= 16'h0000;
        9'h1ee: pm_insn_o <= 16'h0000;
        9'h1ef: pm_insn_o <= 16'h0000;
        9'h1f0: pm_insn_o <= 16'h0d0a; // 	dw	0x0d0a		; \r\n
        9'h1f1: pm_insn_o <= 16'h0d0a; // 	dw	0x0d0a		; \r\n
        9'h1f2: pm_insn_o <= 16'h2a2a; // 	dw	0x2a2a		; **
        9'h1f3: pm_insn_o <= 16'h2a20; // 	dw	0x2a20		; *
        9'h1f4: pm_insn_o <= 16'h4145; // 	dw	0x4145		; AE
        9'h1f5: pm_insn_o <= 16'h2044; // 	dw	0x2044		;  D
        9'h1f6: pm_insn_o <= 16'h6562; // 	dw	0x6562		; eb
        9'h1f7: pm_insn_o <= 16'h7567; // 	dw	0x7567		; ug
        9'h1f8: pm_insn_o <= 16'h2049; // 	dw	0x2049		;  I
        9'h1f9: pm_insn_o <= 16'h4600; // 	dw	0x4600		; F\0
        9'h1fa: pm_insn_o <= 16'h0000;
        9'h1fb: pm_insn_o <= 16'h0000;
        9'h1fc: pm_insn_o <= 16'h0000;
        9'h1fd: pm_insn_o <= 16'h0000;
        9'h1fe: pm_insn_o <= 16'h0000;
        9'h1ff: pm_insn_o <= 16'h0000;
        default: pm_insn_o <= 16'h0000;
      endcase // case(pm_addr_i)

endmodule // serial_wb_program
