`default_nettype none

module testsys(input wire clk_i,
	      input wire rx_i,
	      input wire rst_i,
	      output wire tx_o,
	      output wire [7:0] led_o);

   reg 	     rst_int;
   reg 	     rst_int2;
   


   
   always @(posedge clk_i) begin
      rst_int2 <= rst_i;
      rst_int <= rst_int2;
   end


   
   
   

   serial_wb_top mcu(
		     // Outputs
		     .tx_o		(tx_o),
		     .parport_o		(led_o),
		     .parport_readstrobe_o(),
		     .parport_writestrobe_o(),
		     .wbm_dat_o		(),
		     .wbm_adr_o		(),
		     .wbm_cyc_o		(),
		     .wbm_lock_o	(),
		     .wbm_sel_o		(),
		     .wbm_stb_o		(),
		     .wbm_we_o		(),
		     // Inputs
		     .clk_i		(clk_i),
		     .rst_i		(rst_int),
		     .rx_i		(rx_i),
		     .parport_i		(32'h87651234),
		     .wbm_dat_i		(32'h11553325),
		     .wbm_ack_i		(1'b1),
		     .wbm_err_i		(1'b0),
		     .wbm_rty_i		(1'b0));


endmodule // system
