  
module confport	(input wire clk_i, rst_i, wb_we_i, wb_stb_i, wb_cyc_i,
		 input wire [31:0] wb_dat_i, 
		 input wire [31:0] wb_adr_i,
		 output reg wb_ack_o,
		 output reg [31:0] wb_dat_o, 
		 output reg [31:0] confbus_o,
		 output reg [11:0] confbus_addr_o,
		 output reg confbus_we_o,
		 input wire [31:0] confbus_i
		 );

   // Local signals

   reg [31:0] 			   addr;
   reg [31:0] 			   dat;
   reg 				   we;
   reg 				   stb;
   reg 				   cyc;
   
   
   always @(posedge clk_i) begin
      we <= wb_we_i;
      stb <= wb_stb_i;
      cyc <= wb_cyc_i;
      addr <= wb_adr_i;
      dat <= wb_dat_i;
   end
   
   always @(posedge clk_i) begin
      wb_dat_o <= confbus_i;
   end

   reg state;
   

   always @(posedge clk_i) begin
      if (rst_i) begin
	 confbus_we_o <= 0;
	 confbus_addr_o <= 0;
	 confbus_o <= 0;
	 state <= 0;
      end else begin
	 confbus_we_o <= 0;
	 
	 if(state) begin
	    state <= 0;
	    wb_ack_o <= 0;
	 end else begin
	    if(stb && cyc && we) begin
	       confbus_addr_o <= wb_adr_i[31:2];
	       confbus_o <= wb_dat_i;
	       confbus_we_o <= 1;
	       state <= 1;
	    end

	    wb_ack_o <= stb && cyc;
	 end // else: !if(state)
	 
      end // else: !if(rst_i)
   end // always @ (posedge clk_i)

   
endmodule
