`timescale 1ns / 10ps
`default_nettype none

`include "noc_pkt.vh"
  

module tb_pkt_node(
    input wire clk,rst,

    input wire [`DATAWIDTH+`CTRLWIDTH-1:0]  link_i,
    output wire [`DATAWIDTH+`CTRLWIDTH-1:0] link_o);

   parameter 	 NUM_DESTS  = 1;

   parameter [(NUM_DESTS * 5) - 1: 0] NEXTHOPNODES  = {5'bxxxxx};
   parameter [(NUM_DESTS * 4) - 1: 0]  NEXTHOPDESTS = { 4'bxxxx};
   defparam 			       source.NUM_DESTS = NUM_DESTS;
   defparam 			       source.NODES = NEXTHOPNODES;
   defparam 			       source.DESTS = NEXTHOPDESTS;

   parameter [4:0] 		       THISNODEADDRESS = 5'bxxxxx;
   defparam 			       sink.DESTID = THISNODEADDRESS;
   

   wire [`DATAWIDTH - 1:0]     link_data_i  = link_i[ `DATAWIDTH - 1:0];
   wire [`CTRLWIDTH - 1:0]     link_ctrl_i  = link_i[ `DATAWIDTH +`CTRLWIDTH - 1:`DATAWIDTH];


   

   tb_pkt_testsource source(.clk(clk),.rst(rst),
			    .oktosend(link_ctrl_i[`SENDOKBIT]),
			    .data(link_o[`DATAWIDTH - 1:0]),
			    .ctrl(link_o[`DATAWIDTH+`CTRLWIDTH-2:`DATAWIDTH]));
   

   tb_pkt_testsink sink(.clk(clk),
			.rst(rst),
			.data(link_data_i),
			.ctrl(link_ctrl_i),
			.oktosend(link_o[`DATAWIDTH+`SENDOKBIT]));


   

endmodule // wb_if
