`timescale 1ns / 10ps
//`default_nettype none
`include "noc_pkt.vh"
module tb_pkt_testsink(input wire clk,
    input wire rst,
    input wire [`DATAWIDTH-1:0] data,
    input wire [`CTRLWIDTH-1:0] ctrl,
    output wire 		oktosend);
   
   
   integer 			debugfd;
   
   
   parameter [4:0] 		DESTID = 5'bxxxxx;
   reg [3:0] 			seqno = 0;
   integer 			notacked;
   integer 			packet_ended;
   integer 			recvwords = 0;
   
   assign 			oktosend = 1;
   
   always begin
      notacked = 1;
      packet_ended = 0;
      
      while(1) begin
	 @(posedge clk);
	 if(ctrl[`SENDBIT]) begin

	    recvwords = recvwords + 1;
	    $fwrite(debugfd,"%t, %m: Got %x\n",$time,{ctrl[`LASTBIT:0],data});

	    if(DESTID !== ctrl[`DESTWIDTH-1:0]) begin
	       $display("%m: Got data to id %d, expected %d",ctrl[`DESTWIDTH-1:0],DESTID);
	       $display("%m: The data is %x",data);
	       $stop;
	    end

	    if(data[3:0] !== seqno) begin
	       $display("%m: Got seqno %x, expected seqno %x!",data[3:0],seqno);
	       $stop;
	    end

	    seqno <= seqno + 1;
	 end // if (data[48])

	 if(ctrl[`LASTBIT] && ctrl[`SENDBIT]) begin
//	    $display("%m: Setting notacked to 1");
	    seqno <= 0;
	 end
	 
	 
      end
      
      #5000000;
   end


   task setdebugfd;
      input integer dbgfd;
      begin
	 debugfd = dbgfd;

      end
   endtask // setdebugfd
   
     

endmodule // testsink
