`timescale 1ns / 10ps

module tb_route(
    input wire [4:0] nodeaddr,
    output reg [3:0]  route,
    output reg 	      noroute);


   reg 		      noroute_int;
   reg [3:0] 	      route_int;


   parameter 	 NUM_DESTS  = 1;

   parameter [(NUM_DESTS * 5) - 1: 0] NODES  = {5'bxxxxx};
   parameter [(NUM_DESTS * 4) - 1: 0]  DESTS = { 4'bxxxx};

   
   integer 	      i;

   reg [(NUM_DESTS * 5) - 1 : 0] tempaddr;
   reg [(NUM_DESTS * 4) - 1 : 0] tempdests;
   
   always @(*) begin
      tempaddr = NODES;
      tempdests = DESTS;

      noroute_int = 1;
      route_int = 4'b0;
      for(i = 0; i < NUM_DESTS; i = i + 1) begin
	 if((nodeaddr) == tempaddr[4:0]) begin
	    route_int = tempdests[3:0];
	    noroute_int = 0;
	 end
	 tempaddr = tempaddr >> 5;
	 tempdests = tempdests >> 4;
      end
      
      
   end
   
   always @(*) begin
      route   = route_int;
      noroute = noroute_int;
   end
   


endmodule // wb_findroute
