`timescale 1ns / 10ps
module srl32e(
    input wire       clk,
    input wire 	     d,
    output wire      q,
    input wire [4:0] addr,
    input wire 	     we);

   wire 	     q0,q1,q15;


   SRLC16E srl0(.CLK(clk),
		.D(d),
		.CE(we),
		.A0(addr[0]),
		.A1(addr[1]),
		.A2(addr[2]),
		.A3(addr[3]),
		.Q15(q15),
		.Q(q0));


   SRLC16E srl1(.CLK(clk),
		.D(q15),
		.CE(we),
		.A0(addr[0]),
		.A1(addr[1]),
		.A2(addr[2]),
		.A3(addr[3]),
		.Q15(),
		.Q(q1));


   MUXF5 mux(.I0(q0),.I1(q1),.S(addr[4]),.O(q));


endmodule // srl32e
